<!DOCTYPE html>
<html>
    <head>
        <title>My Test Area | Highschool Online</title>
        <meta charset="utf-8">
        <link rel="shortcut icon" type="image/png" href="/assets/img/logo.png"/>
        <link href="https://fonts.googleapis.com/css?family=Roboto" rel="stylesheet">
        <link href="https://fonts.googleapis.com/css?family=Poppins&display=swap" rel="stylesheet">
        <link href="https://fonts.googleapis.com/css?family=Montserrat&display=swap" rel="stylesheet">
        <link href="https://fonts.googleapis.com/css?family=Gupter&display=swap" rel="stylesheet">
        <link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="stylesheet" href="/assets/css/uikit.min.css" />
        <script src="/assets/js/uikit.min.js"></script>
        <script src="/assets/js/uikit-icons.min.js"></script>
        <script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
        <script id="MathJax-script" async src="https://cdn.jsdelivr.net/npm/mathjax@3.0.0/es5/tex-mml-chtml.js"></script>
        <style>
            * {
                /*font-family: 'Montserrat', sans-serif;*/
                /*border-radius: 5px!important;*/
            }
            .uk-background-success {
                background: #bfe3b4!important;
            }
            .uk-background-danger {
                background: #ff6961!important;
            }
            .uk-background-reason {
                background: #d4e2ff!important;
                color: #5b778a!important;
            }
            li {
              font-family: 'Montserrat', sans-serif!important;
            }
            .uk-border-circle {
                border-radius: 100%!important;
            }
            h1, h1>span, h2, h3, h4 {
                font-family: 'Domine', serif!important;
            }
            .uk-navbar-item, .uk-navbar-nav>li>a, .uk-navbar-toggle {
                min-height: 60px!important;
            }
            .uk-card {
                border-radius: 10px;
            }
            .uk-card-media-left {
                border-bottom-left-radius: 10px;
                border-top-left-radius: 10px;
            }
            .answer {
                padding: 10px;
                border: 0px;
                font-family: 'Poppins', sans-serif;
            }
            .li-answer {
                font-family: 'Roboto', sans-serif!important;
                cursor: pointer;
            }
            .clicked {
                color: #fff!important;
                border: 0px;/* solid #c9c5fc!important;*/
                padding: 5px 0px 5px 0px;
                background: #aca8ff;
                border-radius: 5px;
                font-weight: 600;
            }
            .clicked > button {
                color: #fff!important;
                /*border: 1px solid #fff!important;
                background: #f0f2ff!important;*/
            }
            .mark {
                background: #201766;
            }
            .mark:hover {
                background: #fff;
                color: #201766;
                border: 1px solid #201766;
            }
        </style>
        <!-- Global site tag (gtag.js) - Google Analytics -->
        <script async src="https://www.googletagmanager.com/gtag/js?id=UA-149717145-1">
        </script>
        <script>
          window.dataLayer = window.dataLayer || [];
          function gtag(){dataLayer.push(arguments);}
          gtag('js', new Date());

          gtag('config', 'UA-149717145-1');
        </script>
    </head>
    <body>
        <div class="uk-margin-remove">
            <div class="uk-position-relative uk-height-viewport" style="max-height: 100vh; overflow: auto; background: #f0f2ff;">
            <nav class="uk-box-shadow-medium uk-navbar-container uk-navbar-sticky uk-navbar-transparent" style="background: #fff;" uk-navbar uk-sticky="sel-target: .uk-navbar-container; cls-active: uk-navbar-sticky">
              <div class="uk-navbar-left">
                  <ul class="uk-navbar-nav">
                      <li class="uk-active uk-padding-remove uk-margin-remove"><a href="/me/class"><span uk-icon="icon: chevron-double-left; ratio: 1.5"></span> Go Back Home</a></li>
                  </ul>
              </div>
              <div class="uk-navbar-center">
                  <ul class="uk-navbar-nav">
                      <li><a href="#">Test Area</a></li>
                  </ul>
              </div>
              <div class="uk-navbar-right">
                  <ul class="uk-navbar-nav">
                      <!-- <li class="uk-active"><a href="#"><span uk-icon="icon: cog"></span></a></li> -->
                      <!-- <li><a href="#">|</a></li>
                      <li><a href="sign-in" class="uk-button uk-button-link"><span uk-icon="icon: home"></span></a></li> -->
                  </ul>
              </div>
            </nav>
              <div class="uk-align-center uk-margin-large-top">
                <div class="uk-container uk-container-small timer">
                    <div class="uk-text-right"><span class="uk-h1 uk-text-bold uk-text-warning"><span id="hours">00</span> : <span id="minutes">00</span> : <span id="seconds">00</span></span></div>
                </div>
                <div class="uk-margin main-body uk-margin-large-bottom">
                    <div class="uk-container uk-container-small uk-margin-large-bottom">
                        <div class="uk-card uk-card-default uk-margin-large-bottom">
                            <div class="uk-padding-small uk-hidden score-card uk-text-right">
                                <h1 class="uk-h1 uk-text-bold uk-text-warning result" data-result="0" style="font-size: 3.5rem">100%</h1>
                            </div>
                            <div class="uk-padding questions uk-margin-large-bottom">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="">
                    <div class="uk-margin-small-right" style="position: fixed; right: 0px; bottom: 0px;">
                        <button class="uk-button uk-button-large uk-margin-small-bottom uk-float-right uk-button-primary uk-border-rounded mark mark-test uk-box-shadow"><!-- <i uk-icon="check"></i>  -->Mark Test</button>
                        <a href="#" class="uk-button others uk-button-large uk-margin-small-bottom uk-button-primary uk-border-rounded uk-hidden uk-text-right uk-float-right continue-learning uk-box-shadow"><!-- <i uk-icon="check"></i>  -->Continue Learning</a>
                        <button uk-toggle="target: #modal-exams-init" type="button" class="uk-button uk-button-large uk-margin-small-bottom uk-hidden others uk-button-primary uk-border-rounded uk-text-right uk-float-right take-another-test uk-box-shadow"><!-- <i uk-icon="check"></i>  -->Take Another Test</button>
                    </div>
                </div>

              </div>
            <!-- <div class="uk-section">
                <div class="uk-text-center">Highschool Online &copy; 2019</div>
            </div> -->
            </div>
        </div>

        <!-- <div style="height: 100vh; width: 100vw; background: #e5e2ee; display: block!important; position: fixed; top: 0; z-index: 1000000; border-radius: 0px!important; padding: 0px; margin: 0px;" class="preload-screen uk-margin-remove uk-padding-remove">
            <progress value="10" max="100" class="uk-width-1-1 uk-margin-remove uk-padding-remove uk-progress" style="height: 5px"></progress>
            <div class="uk-align-center uk-position-center"><img src="/assets/img/preloader.gif"></div>
        </div> -->
        <div style="height: 100vh; width: 100vw; position: fixed; top: 0; left: 0; background: rgba(0, 0, 0, 0.6); z-index: 10000000000000" class="uk-hidden preloader">
            <div class="uk-position-center uk-text-center" style="color: #fff"><img src="/assets/img/preloader.gif"><br><p>Please wait, Processing Test...</p></div>
        </div>

        <div id="modal-center" class="uk-flex-top" uk-modal>
            <div class="uk-modal-dialog uk-modal-body uk-margin-auto-vertical">

                <button class="uk-modal-close-outside uk-button-large" type="button" uk-close></button>
                <h2 class="uk-h2">Welldone!!!</h2><h3 class="uk-h3 uk-text-bold"><span>You Scored <span class="uk-text-warning result">Fair</span> on your test</span></h3>
                <p class="uk-text-capitalize">you scored <span class="correct-count">3</span> out of <span class="total-count">10</span> correctly.</p>

            </div>
        </div>

        <div id="modal-exams-init" class="uk-flex-top" uk-modal>
            <div class="uk-modal-dialog uk-modal-body uk-margin-auto-vertical">
                <div class="before uk-text-center">
                    <img src="/assets/img/preloader.gif" class="uk-align-center">
                    <br><p>Loading Topics, Please Wait...</p>
                </div>
                <div class="next uk-hidden uk-text-center">
                    <img src="/assets/img/preloader.gif" class="uk-align-center">
                    <br><p>Loading Question, Please Wait...</p>
                </div>
                <div class="done uk-hidden">
                    <h2 class="uk-h2 uk-text-center">Select a Topic to test yourself with</h2>
                    <hr class="uk-padding-small uk-margin-small">
                    <div>
                        <ul class="options-list uk-child-width-auto" uk-grid>
                        </ul>
                    </div>
                    <hr class="uk-padding-small uk-margin-small">
                    <div class="uk-text-right">
                        <button class="uk-button uk-button-text uk-text-muted surprise-me">Surprise Me</button>&nbsp; 
                        <button class="uk-button uk-button-text uk-text-primary uk-text-bold uk-hidden take-mock">Take a Mock Exam</button>
                    </div>
                </div>
            </div>
        </div>
    </body>

    <script src="https://code.jquery.com/jquery-3.3.1.js" integrity="sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60=" crossorigin="anonymous"></script>
    <script src="https://www.gstatic.com/firebasejs/5.8.2/firebase-app.js"></script>
    <script src="https://www.gstatic.com/firebasejs/5.8.2/firebase-auth.js"></script>
    <script src="https://www.gstatic.com/firebasejs/5.8.2/firebase-firestore.js"></script>
    <script src="https://www.gstatic.com/firebasejs/5.8.2/firebase-storage.js"></script>
    <script src="/assets/js/config.js"></script>
    <!-- <script src="/assets/js/admin.js"></script> -->
    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
    <script>
        let pause = false;
        var audio = new Audio('/assets/sound.mp3');

        let remarks = ['excellent', 'very good', 'good', 'credit', 'credit', 'credit', 'pass', 'pass', 'fail']
        let grades = ['A1', 'B2', 'B3', 'C4', 'C5', 'C6', 'D7', 'E8', 'F9']
        let cores = ['integrated-science', 'core-mathematics', 'social-studies', 'english-language']
        let limit = 10
        function examine(grade) {

        }
        UIkit.modal($('#modal-exams-init')).show()
        let subject = window.location.href.substr(window.location.href.indexOf('/test/') + '/test/'.length, window.location.href.length)
        let sub_type = 'subjects'
        if (cores.includes(subject)) {
            sub_type = 'cores'
        }

        $('.questions').on('click', '.li-answer', function(e) {
            e.preventDefault()
            $(this).addClass('clicked')
            $(this).parents('ul').find('.li-answer').not($(this)).removeClass('clicked')
        })
        var timer
        function countdown(endDate) {
            timer = setInterval(function() {

                let now = new Date().getTime();
                let t = endDate - now;
                
                if (t >= 0) {
                    // audio.play();
                    let hours = Math.floor((t % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
                    let mins = Math.floor((t % (1000 * 60 * 60)) / (1000 * 60));
                    let secs = Math.floor((t % (1000 * 60)) / 1000);
                    document.getElementById("hours").innerHTML = ("0"+hours).slice(-2)
                    document.getElementById("minutes").innerHTML = ("0"+mins).slice(-2)
                    document.getElementById("seconds").innerHTML = ("0"+secs).slice(-2)
                } else {
                    clearInterval(timer)
                    $('.mark-test').trigger('click')
                    // document.getElementById("timer").innerHTML = "The countdown is over!";
                }
                
            }, 1000);
        }

        function shuffle(arra1) {
            var ctr = arra1.length, temp, index;

            while (ctr > 0) {
                index = Math.floor(Math.random() * ctr);
                ctr--;
                temp = arra1[ctr];
                arra1[ctr] = arra1[index];
                arra1[index] = temp;
            }
            return arra1;
        }

        firebase.firestore().collection(sub_type).doc(subject).collection('topics').get()
        .then(function(col) {
            col.forEach(function(topic) {
                // console.log(topic.id, topic.data())
                $('.options-list').append(`<li><a href="#" data-title="${topic.id}" class="subject uk-text-capitalize">${topic.id.substr(topic.id.indexOf('1c-') + 3, topic.id.length).replace(/-/g, ' ')}</a></li>`)
            })
        })
        .then(function() {
            $('.before').addClass('uk-hidden')
            $('.done').removeClass('uk-hidden')
        })

        $('.take-another-test').on('click', function() {
            window.location.reload()
        })

        $('.continue-learning').on('click', function() {
            window.location.href = '/classroom/'+subject
        })

        $('.mark-test').on('click', function() {
            pause = false
            $('.mark-test').addClass('uk-hidden')
            $('.others').removeClass('uk-hidden')
            $('.preloader').removeClass('uk-hidden')
            clearInterval(timer)
            document.getElementById("hours").innerHTML = ("00")
            document.getElementById("minutes").innerHTML = ("00")
            document.getElementById("seconds").innerHTML = ("00")
            let correct = 0, qCount = 0
            $('.result').data('result', 0)
            $.each($('.questions').find('.clicked'), function(i, v) {
                qCount++
                let t = $(this).data('contain')
                let s = $(this).data('cover')
                let q = $(this).data('finder')
                let _this = $(this)
                let option = q.substr(q.lastIndexOf('-') + 1, q.length)
                q = q.substr(0, q.length - (q.length - q.lastIndexOf('-')))
                let x = firebase.firestore().collection(sub_type).doc(subject).collection('topics').doc(t).collection('subtopics').doc(s).collection('questions').doc(q).get()
                .then(function(question) {
                    if (question) {
                        _this.parents('.question-plate').find('.the-reason').removeClass('uk-hidden')
                        if (question.data() == undefined) {
                            _this.parents('.question-plate').find('.the-reason').html('This Question was not Answered')
                            _this.parents('.question-plate').find('.the-reason').addClass('uk-background-danger')
                            return 0
                        } else {
                            _this.parents('.question-plate').find('.the-reason').html(question.data().answer[option].reason)
                            if (question.data().answer[option].correct == "true") {
                                _this.addClass('uk-background-success')
                                return 1
                            } else {
                                _this.addClass('uk-background-danger')
                                return 0
                            }
                        }
                    } else {
                        return 0
                    }
                })
                .then(function(v) {
                    correct += v
                    res = (correct / qCount * 100).toFixed(2)
                    if (parseInt((correct / qCount * 100).toFixed(2)) == (correct / qCount * 100).toFixed(2)) {
                        res = parseInt((correct / qCount * 100).toFixed(2))
                    }
                    $('.correct-count').text(correct)
                    $('.total-count').text(qCount)
                    $('.result').text(res + '%')
                })
                .then(function() {
                    MathJax.typeset()
                    setTimeout(function() {
                        $('.preloader').addClass('uk-hidden')
                        setTimeout(function() {
                            UIkit.modal($('#modal-center')).show()
                            $('.score-card').removeClass('uk-hidden')
                            $(".score-card").animate({ scrollTop: 0 });
                            $(window).scrollTop(0);
                        }, 500)
                    }, 1500)
                })
            })
        })

        $('.surprise-me').on('click', function(e) {
            e.preventDefault()
            let pos = Math.floor(Math.random() * $('.options-list').find('.subject').length)
            $('.options-list').find('.subject').eq(pos).trigger('click')
        })

        $('.options-list').on('click', '.subject', function(e) {
            e.preventDefault()
            $('.done').addClass('uk-hidden')
            $('.next').removeClass('uk-hidden')
            $('.questions').html('')
            let _topic = $(this).data('title')
            firebase.firestore().collection(sub_type).doc(subject).collection('topics').doc(_topic).collection('subtopics').get()
            .then(function(subtopics) {
                let c = 0
                let _questions = []
                subtopics.forEach(function(subtopic) {
                    let _qSet = firebase.firestore().collection(sub_type).doc(subject).collection('topics').doc(_topic).collection('subtopics').doc(subtopic.id).collection('questions').get()
                    .then(function(questions) {
                        let __q = []
                        questions.forEach(function(question) {
                            // __q.push(question.data())
                            c++
                            let _id = 'id-'+c
                            let answer = '<ul class="uk-list">'
                            let d = 0
                            let _the_answer = []
                            for(var ans in question.data().answer) {
                            // console.log(ans)
                                _the_answer.push(`<li class="li-answer uk-margin-remove" data-finder="${question.id}-${ans}" data-cover="${subtopic.id}" data-contain="${_topic}"><button class="answer uk-button uk-button-default uk-border-circle uk-padding-small uk-padding-remove-vertical">${nextLetter(d)}</button>&nbsp; ${question.data().answer[ans].text}</li>`)
                                d++
                            }
                            // _the_answer = shuffle(_the_answer)
                            _the_answer.push(`<li class="li-answer uk-hidden uk-margin-remove clicked" data-finder="{question.id}-{ans}" data-cover="${subtopic.id}" data-contain="${_topic}"><button class="answer uk-button uk-button-default uk-border-circle uk-padding-small uk-padding-remove-vertical"></button>&nbsp; </li>`)
                            for(var ans in _the_answer) {
                                answer+=_the_answer[ans]
                            }
                            answer += '</ul>'
                            // $('.questions').append(
                               let _qTemplate = `
                                <div class="question-plate" data-ask="">
                                    <ul class="uk-list">
                                        <li class="uk-margin-small">
                                            <p class="uk-h5">&nbsp; <span class="quenstion-number"> ${c}</span>.<span class="uk-text-bold"> ${question.data().question}</span></p>
                                            ${answer}
                                        </li>
                                    </ul>
                                    <p class="uk-hidden uk-margin uk-margin-large uk-margin-remove-vertical the-reason uk-border-rounded uk-background-reason uk-padding-small"></p>
                                </div>
                                <hr>`
                                __q.push(_qTemplate)
                                // )

                        })
                        return __q
                    })
                    _questions.push(_qSet)
                })
                // console.log(_questions)
                Promise.all(_questions).then(function(d) {
                    let ___questions = []
                    for( var x in d) {
                        if (x / 2 !== Math.floor(x / 2)) {
                            let temp = d[x].concat(d[ x - 1 ])
                            ___questions = ___questions.concat(temp)
                        }
                    }
                    return ___questions
                })
                .then(function(ret) {
                    var ul = $(".questions");
                    let _newlist = ret
                    shuffle(_newlist)
                    let _c = 0
                    _newlist.forEach(function(c) {
                        if (c !== undefined && _c < 20 && c !== null) {
                        // if (c !== undefined && _c < _newlist.length && c !== null) {
                            ul.append(c)
                        }
                        _c++
                    })
                    $.each(ul.find('div'), function(i, v) {
                        $(this).find('.quenstion-number').text(i + 1)
                    })
                })
                .then(function(ret) {
                    ret = ret
                    MathJax.typeset()
                    UIkit.modal($('#modal-exams-init')).hide()
                    $('.done').addClass('uk-hidden')
                    $('.next').removeClass('uk-hidden')
                    return ret
                })
                .then(function(ret) {
                    ret = ret
                    // console.log(ret) 
                    countdown(new Date(new Date().getTime() + ($('.questions').find('div').length * 1.5 * 1000 * 60)))
                    pause = true
                    return ret
                })
                .catch(function(e) {
                    console.log(e)
                })
            })
        })

        function nextLetter(j) {
            return String.fromCharCode('A'.charCodeAt(0) + j);
        }
        window.onbeforeunload = function () {
            if (pause) {
                return "Do you really want to close? Test will go unmarked";
            }
        };
    </script>

</html>